package jdk.internal.org.objectweb.asm.util;

import jdk.internal.org.objectweb.asm.Attribute;
import jdk.internal.org.objectweb.asm.TypePath;
import jdk.internal.org.objectweb.asm.AnnotationVisitor;
import jdk.internal.org.objectweb.asm.FieldVisitor;

public final class TraceFieldVisitor extends FieldVisitor
{
    public final Printer p;
    
    public TraceFieldVisitor(Printer printer) {
        this(null, printer);
    }
    
    public TraceFieldVisitor(FieldVisitor fieldVisitor, Printer p2) {
        super(327680, fieldVisitor);
        this.p = p2;
    }
    
    @Override
    public AnnotationVisitor visitAnnotation(String descriptor, boolean visible) {
        return new TraceAnnotationVisitor((this.fv == null) ? null : this.fv.visitAnnotation(descriptor, visible), this.p.visitFieldAnnotation(descriptor, visible));
    }
    
    @Override
    public AnnotationVisitor visitTypeAnnotation(int typeRef, TypePath typePath, String descriptor, boolean visible) {
        return new TraceAnnotationVisitor((this.fv == null) ? null : this.fv.visitTypeAnnotation(typeRef, typePath, descriptor, visible), this.p.visitFieldTypeAnnotation(typeRef, typePath, descriptor, visible));
    }
    
    @Override
    public void visitAttribute(Attribute attribute) {
        this.p.visitFieldAttribute(attribute);
        super.visitAttribute(attribute);
    }
    
    @Override
    public void visitEnd() {
        this.p.visitFieldEnd();
        super.visitEnd();
    }
}
